% FILE:        gem0.m
% PURPOSE:     Machine to execute self-describing grammars
%              base version -- risky
% EXAMPLE:     
%   obj = gem0();                         % constructor
%   g   = 'g=;';                          % an empty grammar
%   o = obj.run('', g)                    % does not blow up
%   g   = 'g=''x''"y";';                  % accept 'x', emit 'y'
%   o = obj.run('x', g)                   % result y
%   g   = 'r=s;s=''1'';s=''2'';'          % a '1' or a '2'
%   o = obj.run('1', g)                   % no output
% REQUIRES:
%   iog0.c iog0.h
% TEST:
%   testGem0()

% COPYRIGHT:   1988 W. M. McKeeman.  See license.txt.
% MODS:        1988.06.02 -- mckeeman -- original
%              2008.06.11 -- mckeeman@dartmouth -- moved to MEX
%              2009.04.08 -- luhe@dartmouth     -- stripped to base version

function obj = gem0()
  obj = public();
  %return;
  
  % ----------------------------------------------------
  
  % Run GEM.  gtxt must be deblanked.
  function otxt = run(itxt, gtxt)    
    otxt = iog0(itxt, gtxt);                      % call mex   
  end

  % Collect public fields and fucntions
  function o = public()
    o = struct;
    o.run  = @run;                               % execute GEM
  end

end
