/* Grammar Executing Machine version 3 -- builtin character classes */
static void
gem(void) {
  int fl, fu, isl, isu;
  for (;;) {      
    if (traceit) TRACE();        /* iog3(i,g,T) */
    CHECKCODE();
    switch (mode) {
      /* executing rules */
      case PARSE:
        switch (*p) {
          case 'A':
           if (asciiIOG){	         /* pass ascii */
              if (i-i0>=iN) {mode = BACK; p--;}
              else {o++; CHECKOUT();
                    *o = *i; i++; p++;}        /* input match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'a':
            if (asciiCFG) {	     /* accept ascii */
              if (i-i0>=iN) {mode = BACK; p--;}
              else {i++; p++;}                 /* input match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'D':
            if (digitIOG) {        /* pass digit */
              if (!isdigit(*i)) {mode = BACK; p--;}
              else {o++; CHECKOUT(); 
              *o = *i; i++; p++;}             /* read-match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'd':
            if (digitCFG) {        /* accept digit */
              if (!isdigit(*i)) {mode = BACK; p--;}
              else {i++; p++;}	              /*   read-match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'L':
            fl = lowerIOG;
            fu = upperIOG;
            if (fl||fu) {
              isl = 'a'<=*i && *i<='z';
              isu = 'A'<=*i && *i<='Z';
              if ((fl&&isl) || (fu&&isu)) {
                o++; CHECKOUT(); 
                *o = *i; i++; p++;            /*   read-match */
              } else { 
                mode = BACK; p--;
              }
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'l':
            fl = lowerCFG;
            fu = upperCFG;
            if (fl||fu) {
              isl = 'a'<=*i && *i<='z';
              isu = 'A'<=*i && *i<='Z';
              if ((fl&&isl) || (fu&&isu)) {
                i++; p++;     	               /* read-match */
              } else { 
                mode = BACK; p--;
              }
            } else {
              SEARCHANDRECUR
            }
            break;  
          case ' ': case '\n':              
            p++; break;                       /* skip blank */
          ALPHA                             /* call new rule */              
            SEARCHANDRECUR 
            break;    
          case '\'':                        /* input */
            p++;                              /*   skip over 1rst ' */
            CHECKCODE();
            if (*p == *i)                     /*   read-match */
            {i++; p++;
             CHECKCODE();
            if (*p!='\'') error("missing ' (PARSE)");    
            p++;}    
            else {mode = BACK; p--; p--;}     /*   read-mismatch */
            break;
          case '"':                         /* output */
            p++; o++;                         /*   skip over 1rst " */
            CHECKCODE();
            CHECKOUT();                      
            *o = *p;                          /*   move literal to output*/
            p++; 
            CHECKCODE();
            if (*p!='"') error("missing \" in (PARSE)");    
            p++; break;                  /*   skip over 2nd " */
          case ';':                         /* rule end (parsing) */
            p--;                              /*   back up over ; */
            bs++; 
            CHECKBACK();
            *bs = p;                          /*   save backup pointer */         
            if (psize < 0) return;            /*   empty stack: success */
            p = *ps; ps--;                    /*   return from rule */
            p++; break;                       /*   skip over rule name */
          default:                          /* bad char in grammar */
            error("Unexpected character (PARSE)");
        }
        break;                            /* end of parse step */
        
      /* backtracking */
      case BACK:
      switch (*p) {
        case 'A':
          if (asciiIOG) {o--; i--; p--;}
          else {UNCALL}
          break;
        case 'L':
          if (lowerIOG|upperIOG) {o--; i--; p--;}
          else {UNCALL}
          break;
        case 'D':
          if (digitIOG) {o--; i--; p--;}
          else {UNCALL}
          break;
        case 'a':
          if (asciiCFG) {i--; p--;}
          else {UNCALL}
          break;
        case 'l':
          if (lowerCFG|upperCFG) {i--; p--;}
          else {UNCALL}
          break;
        case 'd':
          if (digitCFG) {i--; p--;}
          else {UNCALL}
          break;
        case ' ': case '\n':
          p--; break;                       /* un-skip blank*/
        ALPHA                             /* un-return from rule */  
          UNCALL break;               
        case '\'':                        /* input */
          i--;                              /* un-get input */
          p--; p--; p--; break;             /* un-skip literal */
        case '"':                         /* output */
          o--;                              /* un-put output */
          p--; p--; p--; break;             /* un-skip literal */
        case '=':                         /* rule begin (backtracking) */
          mode = SEARCH;                    /* forward again */
          p++; break;                       /* skip by = */
        default:
          error("Unexpected character (BACK)");
        }
        break;                            /* end of back step */
        
      /* searching for a rule */
      case SEARCH:
        switch (*p) {
        case ' ': case '\n':
          p++; break;                     /* skip blank*/
        case 'a': case 'A': case 'd': case 'D': case 'l': case 'L':
        ALPHA                             /* phrase name */
          p++; break;                       /* skip over name */
        case '\'':                          /* input*/    
          p++; p++; 
          CHECKCODE();
          if (*p!='\'') error("missing ' (SEARCH)");    
          p++; break;                       /* skip over 'x' */
        case '"':                           /* output*/  
          p++; p++; 
          CHECKCODE();
          if (*p!='"') error("missing \" (SEARCH)");   
          p++; break;                       /* skip over "x" */
        case ';':                         /* rule coming */
          p++;                              /* skip over ; */
           /* skip blanks and newlines if it does not reach the end of the grammar*/
          while (p-p0<pN && (*p==' ' || *p=='\n')) p++;           
          if (p-p0==pN) {                   /* end of code */
            if (psize == 0) error("Unparsable input");
            p = *ps; ps--;               /* back out one rule */
            mode = BACK;                    /* reverse direction */
            p--; break;                     /* un-skip over name */ 
          }
          CHECKNAME(*p);                    /* rule name must be letter */      
          if (*p==**ps) mode = PARSE;       /* lhs is phrase name */
          p++;                         /* skip over lhs */
          CHECKCODE();
          /* skip blanks and newlines */
          while (*p==' ' || *p=='\n') {
              p++;  
              CHECKCODE();
          }
          if (*p!='=') error("missing = (SEARCH)");    
          p++; break;                  /* skip over = */
        default:
          error("Unexpected character (SEARCH)");
        }
        break;
    }
  }
}
