/* Grammar Executing Machine version 4 -- builtin multi-character symbols */
static void
gem(void) {
  char *svp, *svi;
  int fl, fu, isl, isu;
  for (;;) {      
    if (traceit) TRACE();                        /* iog4(i,g,T) */
    CHECKCODE();
    switch (mode) {
      /* executing rules */
      case PARSE:
        switch (*p) {
          case 'A':
           if (asciiIOG){	                       /* pass ascii */
              if (i-i0>=iN) {mode = BACK; p--;}
              else {o++; CHECKOUT();
                    *o = *i; i++; p++;}          /* input match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'a':
            if (asciiCFG) {	                     /* accept ascii */
              if (i-i0>=iN) {mode = BACK; p--;}
              else {i++; p++;}                   /* input match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'D':
            if (digitIOG) {                      /* pass digit */
              if (!isdigit(*i)) {mode = BACK; p--;}
              else {o++; CHECKOUT(); 
              *o = *i; i++; p++;}                /* read-match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'd':
            if (digitCFG) {                      /* accept digit */
              if (!isdigit(*i)) {mode = BACK; p--;}
              else {i++; p++;}	                 /* read-match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'L':
            fl = lowerIOG;
            fu = upperIOG;
            if (fl||fu) {
              isl = 'a'<=*i && *i<='z';
              isu = 'A'<=*i && *i<='Z';
              if ((fl&&isl) || (fu&&isu)) {
                o++; CHECKOUT(); 
                *o = *i; i++; p++;               /* read-match */
              } else { 
                mode = BACK; p--;
              }
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'l':
            fl = lowerCFG;
            fu = upperCFG;
            if (fl||fu) {
              isl = 'a'<=*i && *i<='z';
              isu = 'A'<=*i && *i<='Z';
              if ((fl&&isl) || (fu&&isu)) {
                i++; p++;     	                 /* read-match */
              } else { 
                mode = BACK; p--;
              }
            } else {
              SEARCHANDRECUR
            }
            break;  
          case ' ': case '\n':              
            p++; break;                          /* skip blank */
          ALPHA                                  /* call new rule */              
            SEARCHANDRECUR 
            break;    
          
          case '\'':                             /* input */
            svp = p; svi = i;                    /* in case mismatch */
            p++; CHECKCODE();                    /* skip over 1rst ' */
            if (*p == '\'') {                    /* must be ''' */
              CHECKIN();
              if (*i == *p) {                    /* match ''' */
                i++;
              } else {                           /* read mismatch */
                mode = BACK; p--; p--; break;
              }
              p++; CHECKCODE();                  /* skip over middle ' */
              if (*p != '\'') error("missing matching '");
              p++; break;                        /* skip over matching " */
            }
            while (*p != '\'') {                 /* inside multi ' */
              CHECKIN();
              if (*p == *i) {                    /* read-match */
                i++; p++; CHECKIN(); CHECKCODE();
              } else {                           /* read mismatch */
                mode = BACK; p = svp; p--; p--; 
                i = svi; break;
              }
            }
            p++; break;                          /* skip over final ' */
              
          case '"':                              /* output */
            p++; CHECKCODE();                    /* skip over 1rst " */ 
            if (*p == '"') {                     /* must be """ */
              o++; CHECKOUT(); *o = *p;          /* pass " along */
              p++; CHECKCODE();                  /* skip over middle " */
              if (*p != '"') error("missing matching \"");
              p++; break;                        /* skip over matching " */
            }
            while (*p != '"') {
              o++; CHECKOUT();                   /* move literal to output*/
              *o = *p; p++; CHECKCODE();
            }                          
            p++; break;                          /* skip over matching " */
            
          case ';':                              /* rule end (parsing) */
            p--;                                 /* back up over ; */
            bs++; 
            CHECKBACK();
            *bs = p;                             /* save backup pointer */         
            if (psize < 0) return;               /* empty stack: success */
            p = *ps; ps--;                       /* return from rule */
            p++; 
            break;                          /* skip over rule name */
          default:                               /* bad char in grammar */
            error("Unexpected character (PARSE)");
        }
        break;               /* end of PARSE step */
        
      /* backtracking */
      case BACK:
      switch (*p) {
        case 'A':
          if (asciiIOG) {o--; i--; p--;}
          else {UNCALL}
          break;
        case 'L':
          if (lowerIOG|upperIOG) {o--; i--; p--;}
          else {UNCALL}
          break;
        case 'D':
          if (digitIOG) {o--; i--; p--;}
          else {UNCALL}
          break;
        case 'a':
          if (asciiCFG) {i--; p--;}
          else {UNCALL}
          break;
        case 'l':
          if (lowerCFG|upperCFG) {i--; p--;}
          else {UNCALL}
          break;
        case 'd':
          if (digitCFG) {i--; p--;}
          else {UNCALL}
          break;
        case ' ': case '\n':
          p--; break;                            /* un-skip blank*/
        ALPHA                                    /* un-return from rule */  
          UNCALL break;               
        case '\'':                               /* input */
          p--;                                   /* un-skip literal */ 
          if (*p == '\''){p--; p--; i--; break;} /* undo ''' */
          while (*p != '\'') {p--;i--;}          /* un-get input */                                         
          p--;  break;                           /* un-skip literal */
        case '"':                                /* output */
          p--;                                   /* un-skip literal */ 
          if (*p == '"') {p--; p--; o--; break;} /* undo """ */
          while (*p != '"') {p--;o--;}           /* un-put output */
          p--; break;                            /* un-skip final " */  
        case '=':                                /* rule begin (backtracking) */
          mode = SEARCH;                         /* forward again */
          p++; break;                            /* skip by = */
        default:
          error("Unexpected character (BACK)");
        }
        break;               /* end of BACK step */
        
      /* searching for a rule */
      case SEARCH:
        switch (*p) {
        case ' ': case '\n':
          p++; break;                            /* skip blank*/
        case 'a': case 'A': case 'd': case 'D': case 'l': case 'L':
        ALPHA                                    /* phrase name */
          p++; break;                            /* skip over name */
        case '\'':                               /* input*/
          p++;CHECKCODE();
          if (*p == '\'') {                      /* 2nd ' */
            p++; CHECKCODE();
            if (*p != '\'') error("missing matching '");
          }
          while (*p != '\'') {p++; CHECKCODE();}               
          p++; break;                            /* skip over 'xxxxx' */
          
        case '"':                                /* output*/  
          p++; CHECKCODE();
          if (*p == '"') {                       /* 2nd " */
            p++; CHECKCODE();
            if (*p != '"') error("missing matching \"");
          }
          while (*p != '"') {p++; CHECKCODE();}       
          p++; break;                            /* skip over "xxxxx" */
          
        case ';':                                /* rule coming */
          p++;                                   /* skip over ; */
           /* skip blanks and newlines if it does not reach the end of the grammar*/
          while (p-p0<pN && (*p==' ' || *p=='\n')) p++;           
          if (p-p0==pN) {                        /* end of code */
            if (psize == 0) error("Unparsable input");
            p = *ps; ps--;                       /* back out one rule */
            mode = BACK;                         /* reverse direction */
            p--; break;                          /* un-skip over name */ 
          }
          CHECKNAME(*p);                         /* rule name must be letter */      
          if (*p==**ps) mode = PARSE;            /* lhs is phrase name */
          p++;                                   /* skip over lhs */
          CHECKCODE();        
          while (*p==' ' || *p=='\n') {          /* skip blanks and newlines */
              p++;  
              CHECKCODE();
          }
          if (*p!='=') error("missing = (SEARCH)");    
          p++; break;                            /* skip over = */
        default:
          error("Unexpected character (SEARCH)");
        }
        break;               /* end of SEARCH step */
    }
  }
}
