/* Grammar Executing Machine version 6 -- builtin multi-character phrases */
static void
  gem(void) {
  char *svp, *svi;
  int fl, fu, isl, isu;
  char *pmulti; 
  int count; 
  for (;;) {    
    if (traceit) TRACE();                        /* o=iog6(i,g,'T') */
    CHECKCODE();
    switch (mode) {
      /* executing rules */
      case PARSE:
        switch (*p) {
          case ' ': case '\n':
            p++; break;                          /* skip blank */
          case 'A':
            if (asciiIOG){	                     /* pass ascii */
              if (i-i0>=iN) {mode = BACK; p--;} 
              else {o++; CHECKOUT();
                *o = *i; i++; p++;}              /* input match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'a':
            if (asciiCFG) {	                     /* accept ascii */
              if (i-i0>=iN) {mode = BACK; p--;}
              else {i++; p++;}                   /* input match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'D':
            if (digitIOG) {                      /* pass digit */
              if (!isdigit(*i)) {mode = BACK; p--;}
              else {o++; CHECKOUT();
                *o = *i; i++; p++;}              /* read-match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'd':
            if (digitCFG) {                      /* accept digit */
              if (!isdigit(*i)) {mode = BACK; p--;}
              else {i++; p++;}	                 /* read-match */
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'L':
            fl = lowerIOG;
            fu = upperIOG;
            if (fl||fu) {
              isl = 'a'<=*i && *i<='z';
              isu = 'A'<=*i && *i<='Z';
              if ((fl&&isl) || (fu&&isu)) {
                o++; CHECKOUT();
                *o = *i; i++; p++;               /* read-match */
              } else {
                mode = BACK; p--;
              }
            } else {
              SEARCHANDRECUR
            }
            break;
          case 'l':
            fl = lowerCFG;
            fu = upperCFG;
            if (fl||fu) {
              isl = 'a'<=*i && *i<='z';
              isu = 'A'<=*i && *i<='Z';
              if ((fl&&isl) || (fu&&isu)) {
                i++; p++;     	                 /* read-match */
              } else {
                mode = BACK; p--;
              }
            } else {
              SEARCHANDRECUR
            }
            break;
                        
          case '<':                              /* call multi-char name*/                    
          ALPHA                                  /* call single-char name */
            SEARCHANDRECUR
            break;
                    
          case '\'':                             /* input */
            svp = p; svi = i;                    /* in case mismatch */
            p++; CHECKCODE();                    /* skip over 1rst ' */
            if (*p == '\'') {                    /* must be ''' */
              CHECKIN();
              if (*i == *p) {                    /* match ''' */
                i++;
              } else {                           /* read mismatch */
                mode = BACK; p--; p--; break;
              }
              p++; CHECKCODE();                  /* skip over middle ' */
              if (*p != '\'') error("missing matching '");
              p++; break;                        /* skip over matching " */
            }
            while (*p != '\'') {                 /* inside multi ' */
              CHECKIN();
              if (*p == *i) {                    /* read-match */
                i++; p++; CHECKIN(); CHECKCODE();
              } else {                           /* read mismatch */
                mode = BACK; p = svp; p--; p--;
                i = svi; break;
              }
            }
            p++; break;                          /* skip over final ' */
          case '"':                              /* output */
            p++; CHECKCODE();                    /* skip over 1rst " */
            if (*p == '"') {                     /* must be """ */
              o++; CHECKOUT(); *o = *p;          /* pass " along */
              p++; CHECKCODE();                  /* skip over middle " */
              if (*p != '"') error("missing matching \"");
              p++; break;                        /* skip over matching " */
            }
            while (*p != '"') {
              o++; CHECKOUT();                   /* move literal to output*/
              *o = *p; p++; CHECKCODE();
            }
            p++; break;                          /* skip over matching " */
                        
          case ';':                              /* rule end (parsing) */
            p--;                                 /* back up over ; */
            bs++;
            CHECKBACK();
            *bs = p;                             /* save backup pointer */
            if (psize < 0) return;               /* empty stack: success */
            p = *ps; ps--;                       /* return from rule */
            if (*p=='<'){ 
              while (*p!='>') {p++; CHECKCODE();}
            }
            p++;                                 /* skip single name or >*/
            break;
              
          default:                               /* bad char in grammar */
            error("Unexpected character (PARSE)");
        }
        break;              /* end of PARSE step */
                
      /* backtracking */
      case BACK:
        switch (*p) {
          case ' ': case '\n':
            p--; break;                          /* un-skip blank */
          case 'A':
            if (asciiIOG) {o--; i--; p--;}
            else {UNCALL}
            break;
          case 'L':
            if (lowerIOG|upperIOG) {o--; i--; p--;}
            else {UNCALL}
            break;
          case 'D':
            if (digitIOG) {o--; i--; p--;}
            else {UNCALL}
            break;
          case 'a':
            if (asciiCFG) {i--; p--;}
            else {UNCALL}
            break;
          case 'l':
            if (lowerCFG|upperCFG) {i--; p--;}
            else {UNCALL}
            break;
          case 'd':
            if (digitCFG) {i--; p--;}
            else {UNCALL}
            break;                 
          ALPHA                                  /* un-return from rule */
            UNCALL break;
          case '>':
            p--;                                 /* un-skip > */
            while(*p!='<') p--;
            UNCALL break;
          case '\'':                             /* input */
            p--;                                 /* un-skip literal */
            if (*p == '\''){p--; p--; i--; break;} /* undo ''' */
            while (*p != '\'') {p--;i--;}        /* un-get input */
            p--;  break;                         /* un-skip literal */
          case '"':                              /* output */
            p--;                                 /* un-skip literal */
            if (*p == '"') {p--; p--; o--; break;} /* undo """ */
            while (*p != '"') {p--;o--;}         /* un-put output */
            p--; break;                          /* un-skip final " */
          case '=':                              /* rule begin (backtracking) */
            mode = SEARCH;                       /* forward again */
            p++; break;                          /* skip by = */
          default:
            error("Unexpected character (BACK)");
        }
        break;               /* end of BACK step */
                
      /* searching for a rule */
      case SEARCH:        
        switch (*p) {
          case ' ': case '\n':
            p++; break;                          /* skip blank*/ 
            
          case 'a': case 'A': case 'd': case 'D': case 'l': case 'L':
          ALPHA                                  /* single phrase name */
            p++; break;                          /* skip over name */
          case '<':                              /* multiply prase name*/
            while (*p!='>'){
              p++;CHECKCODE();
            }
            p++; break;                          /* skip > */
                        
          case '\'':                             /* input*/
            p++;CHECKCODE();
            if (*p == '\'') {                    /* 2nd ' */
              p++; CHECKCODE();
              if (*p != '\'') error("missing matching '");
            }
            while (*p != '\'') {p++; CHECKCODE();}
            p++; break;                          /* skip over 'xxxxx' */
          case '"':                              /* output*/
            p++; CHECKCODE();
            if (*p == '"') {                     /* 2nd " */
              p++; CHECKCODE();
              if (*p != '"') error("missing matching \"");
            }
            while (*p != '"') {p++; CHECKCODE();}
            p++; break;                          /* skip over "xxxxx" */
                        
          case ';':                              /* rule coming */           
            p++;                                 /* skip over ; */
            /* skip blanks and newlines */
            while (p-p0<pN && (*p==' ' || *p=='\n')) p++;
            if (p-p0==pN) {                      /* end of code */
              if (psize == 0) error("Unparsable input");
              p = *ps; ps--;                     /* back out one rule */
              mode = BACK;                       /* reverse direction */
              p--; break;                        /* un-skip over name ??*/
            }            
            /* The rule name is either a letter or <stuff> */
            if (*p=='<') {                       /* multi-char name */
              pmulti=*ps;
              pmulti++;                          /* skip < (parse)*/
              p++; CHECKCODE();                  /* skip < (code) */
              CHECKALPHA(*p);                    /* check (code)*/
              count=1;                           /* count chars inside <>*/
              while (*p==*pmulti) {              /* match */
                pmulti++;
                p++; CHECKCODE();                /* step code; check bound */
                if (*p=='>') break;              /* end of <stuff> */
                if (*p!='*' || count!=1) {       /* not * or not <A*> */
                  CHECKMULTIName(*p);
                } else { p++; CHECKCODE();       /* Example: <A*> */
                  if (*p!='>')                   /* > should follow <A* */
                    error("unexpected multi-character phrase name");
                  p--;                           /* back to point to * */
                }
                count++;
              }
              if (*p==*pmulti) {                 /* break if *p=='>' */        
                mode=PARSE;                      /* *p==*pmulti='>' */
                p++;CHECKCODE();                 /* skip > */
              } else {                           /* skip multi-char name*/                      
                while (*p!='>'){                 /* until *p=='>' */
                  p++; CHECKCODE();
                  if (*p=='>') break;
                  if (*p!='*'|| count!=1) {
                    CHECKMULTIName(*p);
                  } else { p++; CHECKCODE();
                    if (*p!='>')
                      error("unexpected multi-character phrase name"); }
                    count++;
                  }
                p++;  CHECKCODE();               /* skip > */
              }              
            }else{                               /* single phrase name */              
              CHECKNAME(*p);                     /* name must be letter */
              if (*p==**ps) mode = PARSE;        /* lhs is phrase name */
              p++;                               /* skip over lhs */
              CHECKCODE();
            }
            while (*p==' ' || *p=='\n') {        /* skip blanks and \n */
              p++;
              CHECKCODE();
            }
            if (*p!='=') error("missing = (SEARCH)");
            p++; break;                          /* skip over = */
          default:
            error("Unexpected character (SEARCH)");
        }
        break;               /* end of SEARCH step */
    }
  }
}
