/* FILE:     runX86.c
 * PURPOSE:  execute x86 code
 * METHOD:   pass the assembled X86 code.
 *           cast the code into a pointer to a function
 *           call the function (the code better be right)
 *           report integer return value to the caller.
 */

# include "mex.h"

typedef unsigned char byte;

void
mexFunction(
  int nlhs, mxArray *plhs[],
  int nrhs, const mxArray *prhs[]
) {
  void *code;
  int32_T (*t)(void);
  int32_T res;
  const int dims[] = {1,1};
  
  mxAssert(nrhs == 1, "bad call: use runx86(code)");    

  code = mxGetData(prhs[0]);                      /* code address */    
  t = (int32_T (*)(void))code;                    /* ptr to fn */
  res = t();                                      /* call it */
  
  mxAssert(nlhs<=1, "bad call: use val = runX86(code)");
  plhs[0] = mxCreateNumericArray(2, dims, mxINT32_CLASS, mxREAL);
  *(int32_T*)mxGetData(plhs[0]) = res; 
}

